package example.company;

import java.util.Iterator;

public class Manager extends Employee {
	public Manager(String name, String position, int salary) {
		super(name, position, salary);
	}

	public void check() {
		super.check(); // check as employee

		// managers should not receive less salary than their subordinates
		for (Iterator iter = getSubordinates(); iter.hasNext();) {
			Employee subordinate = (Employee) iter.next();
			if (getSalary() < subordinate.getSalary()) {
				System.out.println(	"CHECK: "
									+ getName()
									+ " receives less salary than "
									+ subordinate.getName());
			}

		}
	}

	public Iterator/*Employee*/ getSubordinates() {
		return new Iterator() {
			private Iterator/*Department*/ deptIter = getDepartments();
			private Iterator/*Employee*/   emplIter = null;

			public boolean hasNext() {
				if (emplIter != null && emplIter.hasNext()) return true;
				// end of current department
				while (deptIter.hasNext()) { // get next non-empty departement
					Department department = (Department)deptIter.next();
					emplIter = (Iterator/*Employee*/)department.getMembers();
					if (emplIter.hasNext()) return true;
				}
				return false; // end of company
			}

			public Object next() {	return emplIter.next(); }
			public void remove() {}
		};
	}
}
