package example.company;

import java.util.Iterator;

public aspect Printing {

	public void Company.print() {
		System.out.println("---Company---");
		for (Iterator/*Department*/ deptIter = this.getDepartments(); deptIter.hasNext();) {
			Department dept = (Department) deptIter.next();
			dept.print();
			System.out.println();
		}
	}
	
	public void Department.print() {
		System.out.println("---Department: " + this.getName() + "---");
		System.out.println(" Manager: ");
		Manager manager = this.getManager();
		if (manager != null) manager.print();
		System.out.print(" Members: ");
		for (Iterator/*Employee*/ memberIter = this.getMembers(); memberIter.hasNext();) {
			Employee member = (Employee) memberIter.next();
			if (member != manager) {
				System.out.println();
				member.print();
			}	
		}
	}
	
	public void Employee.print() {
		System.out.println("\tName: " + this.getName());
		System.out.println("\tPosition: " + this.getPosition());
		System.out.println("\tSalary: " + this.getSalary());
	}
	

	public static void main(String[] args) {
		Company c = new Company();
		Department rd    = new Department("R&D");
		Department admin = new Department("Administration");
				
		Manager  john = new Manager ("John", "R&D Manager",    4000);
		Employee paul = new Employee("Paul", "Researcher",     1000);
		Employee mick = new Employee("Mick", "System Engineer", 500);
				
		c.addDepartment(rd);
		c.addDepartment(admin);

		rd   .setManager(john);
		rd   .addMember (paul);
		rd   .addMember (mick);

		mick.setSalary(mick.getSalary()*10);
		Employee robert = new Employee("Robert", "Researcher", 4500);
		rd.addMember(robert);
		
		admin.setManager(john);

		c.print();
	}		

	
}
