package example.company;

import java.util.Iterator;

public aspect SalaryChecking {

	pointcut salaryChange(Employee e) : 
		call(void Employee.setSalary(int)) 
		&& target(e);
		
	pointcut memberChange(Department d) : 
		(call(void Department.addMember(Employee)) 
		 || call(void Department.setManager(Manager)))
	    && target(d);
	
	after(Employee e) returning : salaryChange(e) {
		e.check();
		for (Iterator managerIter = e.getDepartments(); managerIter.hasNext();) {
			Department department = (Department) managerIter.next();
			department.getManager().check();
		}
	}
	
	after(Department d) returning : memberChange(d) {
		d.getManager().check();
	}
}
