package example.figures;

// Open Classes

aspect Drawing {

	void Line.draw() {
		display.drawLine(getP1().getX(), getP1().getY(), 
		              getP2().getX(), getP2().getY());
	}
	void Point.draw() {
		display.drawOval(getX()-5, getY()-5, getX()+5, getY()+5);
	}

	void Figure.draw() {
		FigureElement[] figureElements = figureElements();
		for (int i = 0; i < figureElements.length; i++) 
			figureElements[i].draw();
	}	

	void FigureElement.draw() {}

	// call introduced draw method when drawing

	void around(Figure fig)
	 : call(void Figure.dump()) && target(fig) {
		System.out.println("---Display---");
		fig.draw();
		System.out.println("-------------");
	}
}
