package example.figures;

import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

class Figure {

	List elementList = new LinkedList(); // of FigureElements
	
	//------------------------------------------------------------------

	private void addElement(FigureElement fe) {
		elementList.add(fe);
	}

	Point makePoint(Display display, int x, int y) {
		Point p = new Point(display, x, y);
		addElement(p);
		return p;
	}

	Line makeLine(Display display, int x1, int y1, int x2, int y2) {
		Line l = new Line(display, x1, y1, x2, y2);
		addElement(l);
		return l;
	}

	FigureElement[] figureElements() {
		FigureElement[] elementArray = new FigureElement[elementList.size()];
		elementList.toArray(elementArray);
		return elementArray;
	}

	void dump() {
		System.out.println("Figure:");
		FigureElement[] fes = figureElements();
		for (int i = 0; i < fes.length; i++) 
			System.out.println(fes[i]);
		System.out.println();
	}

	public static void main(String args[]) {
		Display disp = new Display();
		Figure fig = new Figure();

		Point p1 = fig.makePoint(disp, 0, 0);
		Point p2 = fig.makePoint(disp, 50, 50);
		Line l1 = fig.makeLine(disp, 100, 50, 150, 100);
		Line l2 = fig.makeLine(disp, 150, 50, 100, 100);

		fig.dump();

		p1.setX(30);
		l2.setP2(p2);

		fig.dump();
	}
}
