#|<--                          80 columns                                   ->|#

(let ((time-stamp "Time-stamp: <2002-02-18 13:13:09 gregor>"))
  (display (string-append "tests=oc.scm:  " (substring time-stamp 13 29)))
  (newline))


(define main-program
  `((class main object
      (method void init () (super init))
      (method int main ()
        (let (((employee john) (new employee "john" 100))
              ((employee bob)  (new employee "bob"  200)))

          (send john add-manager bob)
          (send john add-manager john)
          
	  (send john print-with-salary)
	  (send bob  print-with-salary)

	  0)))

    (class employee object

      (field string name)
      (field int salary)
      (field (list employee) managers)

      (method void init ((string name) (int salary))
        (super init)
        (fset! this name     name)
	(fset! this salary   salary)
        (fset! this managers '()))

      (method void print () (write (fget this name)))

      (method void add-manager ((employee mgr))
        (fset! this managers (cons mgr (fget this managers))))
      (method void check ()
        (write 'checking:)
        (send this print)
        (let (((int n) (length (fget this managers))))
          (if (< n 1)
              (write ':too-few-managers)
              #f)
          (if (< 3 n)
              (write ':too-many-managers)
              #f))
        (newline))

      (method int pay ()
        (write 'paying:) (send this print) (newline)
	(fget this salary)))

     (introduce employee
       (method void print-with-salary ()
	       (write 'name:)   (write (fget this name))   (newline)
	       (write 'salary:) (write (fget this salary)) (newline)))))


(add-test 'oc0
	  "open classes"
	  (oc:weave (parse-program main-program))
	  0
	  '(name:   "john" NL
	    salary: 100    NL
	    name:   "bob"  NL
	    salary: 200    NL
	    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(add-test 'oc1
	  "overriding a method"
	  (oc:weave
	   (parse-program
	    `((class main object
		(method void init () (super init))
		(method int main () (write 'hello)      (newline) 0))
	      (introduce main
		(method int main () (write 'overriden!) (newline) 1)))))
	  1
	  '(overriden! NL))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; example : figures

(define drawing
  (figures-with-decls

     '((introduce figure
	 (method void draw ()
	   (send this draw-1 (fget this element-list))))
       (introduce figure
	 (method void draw-1 ( (list elements))
	   (if (null? elements)
	       'done
	       (let ()
		 (send (send elements car) draw)
		 (send this draw-1 (send elements cdr))))))

       (introduce figure-element
	 (method void draw ()))

       (introduce line
	 (method void draw ()
	   (let (((point p1) (send this get-p1))
		 ((point p2) (send this get-p2)))
	     (send (fget this display) draw-line
		   (send p1 get-x) (send p1 get-y)
		   (send p2 get-x) (send p2 get-y)))))

       (introduce point
	 (method void draw ()
	   (let (( (int x) (send this get-x) )
		 ( (int y) (send this get-y) ))
	     (send (fget this display) draw-oval (- x 5) (- y 5) (+ x 5) (+ y 5)))))

       (introduce figure		; overrinding
 	 (method void dump ()
	   (write '----display---)
	   (newline)
	   (send this draw)
	   0))

       )))

(add-test 'oc2
	  "oc with figures"
	  (oc:weave (parse-program drawing))
	  0
	  '(----display--- NL
	    (draw-line 150 50 100 100) NL
	    (draw-line 100 50 150 100) NL
	    (draw-oval 45 45 55 55) NL
	    (draw-oval -5 -5 5 5) NL
	    "moving elements" NL
	    ----display--- NL
	    (draw-line 150 50 50 50) NL
	    (draw-line 100 50 150 100) NL
	    (draw-oval 45 45 55 55) NL
	    (draw-oval 25 -5 35 5) NL)
	  )

