#|<--                          80 columns                                   ->|#

(let ((time-stamp "Time-stamp: <2002-02-18 13:13:09 gregor>"))
  (display (string-append "tests=trav.scm:  " (substring time-stamp 13 29)))
  (newline))


(define salary-program
  (lambda (visitor-method-decls)
    `((class main object
      (method void init () (super init))
      (method int main ()
	(let (((Department admin) (new Department))
	      ((Department rAndD) (new Department)))
	  (let (((Company c) (new Company admin rAndD)))
	    (send admin setEmployee (new Employee 100))
	    (send rAndD setEmployee (new Employee 120))
	    (let (((SalaryTotalling visitor) (new SalaryTotalling)))
	      (traverse '((from Company) (to Salary))
			c
			visitor)
	      (send visitor getTotal))))))

    (class Company object
      (field Department admin)
      (field Department rAndD)
      (method void init ((Department a) (Department r)) 
	(super init)
	(fset! this admin a)
	(fset! this rAndD r)))

    (class Department object
      (field Employee employee)
      (method void init () (super init))
      (method void setEmployee ((employee e)) (fset! this employee e)))

    (class Employee object
      (field Salary salary)
      (method void init ((int s)) (super init) (fset! this salary (new Salary s this))))

    (class Salary object
      (field int intVal)
      (method void init ((int iv) (Employee employee))
	      (fset! this intVal iv))
      (method int intValue() (fget this intVal)))

    (class SalaryTotalling object
      (field int total)
      (method void init () (fset! this total 0))
      (method void addSalary ((int amount)) 
	(fset! this total (+ (fget this total) amount)))
      ,@visitor-method-decls
      
      (method int getTotal () (fget this total)))
      
    )))

(define count-elements
  (lambda (trav-spec visitor-method-decls)
    (figures-with-decls
      `((class count-elements-visitor object
	       (field int counter)
	       (method void init () (super init))
	       (method void addCounter ()
		       (fset! this counter
			      (+ 1 (fget this counter))))
	       ,@visitor-method-decls
	       
	       (method int get-counter () (fget this counter))))

      ;; this is main
     `(let (((figure fig)  (new figure))
	    ((display disp) (new display)))
	(let (((point  p1) (send fig make-point disp  0  0))
	      ((point  p2) (send fig make-point disp 50 50))
	      ((line   l1) (send fig make-line  disp 100 50 150 100))
	      ((line   l2) (send fig make-line  disp 150 50 100 100))

	      ((count-elements-visitor v) 
	                   (new count-elements-visitor)))

	  (traverse ',trav-spec fig v)
	  (send v get-counter)))
     )))

(add-test 'traversal1
	  "salary traversal"
	  (salary-program
	   '((method void visit ((object obj))
		     (if (instanceof? Salary obj)
			 (let (( (int amount) (send obj intValue) ))
			   (write 'at_salary:_) (write amount)	(newline)
			   (send this addSalary amount))
			 'void))))
	  220
	  '(at_salary:_ 100 NL
	    at_salary:_ 120 NL))

(add-test 'traversal2
	  "counting figure elements"
	  (count-elements '(from figure  to figure-element)
			  '((method void visit ((object o))
				    (if (instanceof? figure-element o)
					(send this addCounter)
					'void))))
	  8
	  '())

(add-test 'traversal3
	  "counting figure elements excluding direct points"
	  (count-elements '(from figure through figure-element to figure-element)
			  '((method void visit ((object o))
				    (if (instanceof? figure-element o)
					(send this addCounter)
					'void))))
	  6
	  '())
