#|<--                          80 columns                                   ->|#

(let ((time-stamp "Time-stamp: <2002-09-17 10:41:55 Hidehiko Masuhara>"))
  (display (string-append "tests=travex.scm:  " (substring time-stamp 13 29)))
  (newline))

(load "tests=trav.scm")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; calling visit methods by class name
;;; NOTE: the next three tests supersede the original tests.

(add-test 'traversal1
	  "salary traversal"
	  (salary-program
	   '((method void visit-Salary ((Salary obj))
		     (let (( (int amount) (send obj intValue) ))
		       (write 'at_salary:_) (write amount)	(newline) 
		       (fset! this total (+ (fget this total) amount))))))
	  220
	  '(at_salary:_ 100 NL
	    at_salary:_ 120 NL))

(add-test 'traversal2
	  "counting figure elements"
	  (count-elements '(from figure  to figure-element)
			  '((method void visit-figure-element ((figure-element o))
				    (send this addCounter))))
	  8
	  '())

(add-test 'traversal3
	  "counting figure elements excluding direct points"
	  (count-elements '(from figure through figure-element to figure-element)
			  '((method void visit-figure-element ((figure-element o))
				    (send this addCounter))))
	  6
	  '())

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; visitor methods as advice

(add-test 'traversal4
	  "traversal ptc for salary"
	  (salary-program
	   '((before (and (traversal accumlator)
			  (target (Salary obj)))
		     (let (( (int amount) (send obj intValue) ))
		       (write 'at_salary:_) (write amount)	(newline)
		       (send accumlator addSalary amount)))))
	  220
	  '(at_salary:_ 100 NL
	    at_salary:_ 120 NL))

(add-test 'traversal5
	  "traversal ptc for counting fig.elms."
	  (count-elements '(from figure  to figure-element)
			  '((before (and (traversal element-counter)
					 (target (figure-element o)))
				    (send element-counter addCounter))))
	  8
	  '())

(add-test 'traversal6
	  "traversal ptc for counting direct fig.elms."
	  (count-elements '(from figure  to figure-element)
			  '((around (and (traversal element-counter)
					 (target (figure-element o)))
				    (send element-counter addCounter)) ; not proceeds
			    ))
	  4
	  '())
