#|<--                               90 columns                                        ->|#

(let ((time-stamp "Time-stamp: <2002-06-11 12:59:41 gregor>"))
  (display (string-append "weaver=oc-ct.scm: " (substring time-stamp 13 29)))
  (newline))


;;; A:  source program except OC decls
;;; 	ID:     signature of method decl
;;; 	effect: add to target class decl
;;; 
;;; B: source program OC decls
;;;    ID:     signature of method decl
;;;    effect: add to target class decl
;;; 
;;; X: target code
;;;    JPs: class decls
;;; 

(define oc:weave
  (lambda (pgm);-> pgm
    (let ((pgm       (remove-oc-mdecls  pgm))			    ;this is A
          (oc-mdecls (gather-oc-mdecls pgm)))			    ;this is B
      (make-program						    ;X is a new program
       (map (lambda (cdecl)					    ;cdecl is a JP
	      (let* ((cname (class-decl-cname cdecl))
		     (sname (class-decl-sname cdecl))
		     (per-class-oc-mdecls
		            (lookup-oc-mdecls cname		    ;get elements of B
					      oc-mdecls)))	    ;matching JP
		(make-class-decl cname sname			    ;weave together into
		  (append (copy-oc-mdecls cname per-class-oc-mdecls);new class
			  (class-decl-decls cdecl)))))
	    (program-decls pgm))))))  

(define lookup-oc-mdecls
  (lambda (cname all-oc-mdecls)
    (collect-if
     (lambda (oc-mdecl)
       (eq? (oc-mdecl-cname oc-mdecl)
	    cname))
     all-oc-mdecls)))

(define copy-oc-mdecls
  (lambda (cname per-class-oc-mdecls)
    (map (lambda (oc-mdecl)
           (make-method-decl cname
                             (oc-mdecl-rtype oc-mdecl)
                             (oc-mdecl-mname oc-mdecl)
                             (oc-mdecl-params oc-mdecl)
                             (oc-mdecl-body oc-mdecl)))
         per-class-oc-mdecls)))

;;;

(define gather-oc-mdecls
  (lambda (pgm)
    (collect-if oc-mdecl? (program-decls pgm))))

(define remove-oc-mdecls
  (lambda (pgm)
    (make-program (collect-if-not oc-mdecl? (program-decls pgm)))))

;;;
;;;
;;;

(define-struct oc-mdecl (cname rtype mname params body))

;; the syntax is like an old AspectJ's oc-mdecl
;; (introduce employee
;;  (method void print-with-salary ()
;;    (write 'name:)   (write (fget this name))   (newline)
;;    (write 'salary:) (write (fget this salary)) (newline)))

(set! parse-decl
  (around-wrap parse-decl
    (lambda (original-parse-decl sexp)
      (if (eqv? (car sexp) 'introduce)
          (let ((cname (cadr sexp))
                (mdecl (parse-member-decl #f (caddr sexp))))
	    (make-oc-mdecl cname
			   (method-decl-rtype mdecl)
			   (method-decl-mname mdecl)
			   (method-decl-params mdecl)
			   (method-decl-body mdecl)))
          (original-parse-decl sexp)))))
